
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package csa.gui;
import csa.gui.image.*;
import javax.swing.*;

import java.awt.image.*;
import java.awt.*;
import java.util.*;
import csa.util.*;
import java.io.*;
import java.awt.MediaTracker;

/**
 *
 * @author Malban
 */
public class ImageSequencer extends JPanel
{
    private static HashMap<String, java.awt.Image> mImageCache = new HashMap<String, java.awt.Image>();
    private static int id =0;
    public static final void resetImageCache() {mImageCache = new HashMap<String, java.awt.Image>(); }
    public static final int getChacheSize() {return mImageCache.size();}
    Vector<BufferedImage> bimages = new Vector<BufferedImage>();

    private MediaTracker tracker = new MediaTracker(this);
    Toolkit toolkit = Toolkit.getDefaultToolkit();

    // "D:\Dev\JavaProjects\JPortal\images\jewels\jewel darkblue0000.bmp"
    // only up to 99

    /** Loads a single image and sets an opacity
     *
     * @param name pathname
     */
    private ImageSequencer()
    {
    }


    /** Loads a count images of kind "image00.png" count replaces "00"
     *
     * @param name pathname
     * @param count Steps to fade of images
     */
    public static ImageSequencer createFromImageFading(String name, int count)
    {
        name = csa.util.UtilityString.cleanFileString(name);
        ImageSequencer i = new ImageSequencer();
        i.initImageFading(name, count);
        return i;
    }

    /** Loads a count images of kind "image00.png" count replaces "00"
     *
     * @param name pathname
     * @param count number of images
     */
    public static ImageSequencer createFromImageSequence(String name, int count)
    {
        name = csa.util.UtilityString.cleanFileString(name);
        ImageSequencer i = new ImageSequencer();
        i.initImageSequence(name, count);
        return i;
    }
    public static ImageSequencer createByRotation(String name, int steps)
    {
        name = csa.util.UtilityString.cleanFileString(name);
        ImageSequencer i = new ImageSequencer();
        i.initRotationSequence(name, steps);
        return i;
    }

    public Vector<BufferedImage> getBufferedImages()
    {
        return bimages;
    }

    public Vector<Icon> getAsIcons()
    {
        Vector<Icon> icons = new Vector<Icon>();
        for (int i=0; i<bimages.size(); i++)
        {
            BufferedImage image = bimages.elementAt(i);
            ImageIcon icon = new ImageIcon(image);
            icons.addElement(icon);
        }
        return icons;
    }

    private boolean initRotationSequence(String name, int steps)
    {
        if  (!initImageSequence(name, 1))
        {
            return false;
        }
        // remove the element itself, because it will be rotated by 0 degrees
        // easier this way because the size will be changed
        BufferedImage bimage = bimages.elementAt(0);
        bimages.clear();
        
        int angleInc = 360 / steps;
        int angleNow = 0;
        int size;
        int h = bimage.getHeight();
        int w = bimage.getWidth();
        if (h>w) size = h; else size=w;
        int difSize = h-w;
        int difHalf = difSize/2;


//        size = h*h+w*w;
//        size =(int) Math.sqrt((double) (size+1));
size+=10;
        for (int i=0; i<steps; i++)
        {
            BufferedImage dimg = new BufferedImage(size, size, bimage.getType());
            Graphics2D g = dimg.createGraphics();
            g.rotate(Math.toRadians(angleNow), h/2, h/2);
            angleNow+=angleInc;
            g.drawImage(bimage, null, difHalf, 0);
            
            // now Crop to original size
            //BufferedImage bimageCropped = dimg.getSubimage(0, difHalf, h, w);
            bimages.addElement(dimg);
          //  bimages.addElement(bimage);

        }
        return true;
    }

    private boolean initImageFading(String name, int steps)
    {
        if  (!initImageSequence(name, 1))
        {
            return false;
        }
        int stepIncread = 255/(steps-2);
        int opaqueness = stepIncread;
        BufferedImage bimage = bimages.elementAt(0);
        //bimages.clear();
        for (int s = 0; s<(steps-2);s++)
        {
            OpacityFilter filter = new OpacityFilter(255-opaqueness);
            bimages.addElement(filter.filter(bimage, null));
            opaqueness+=stepIncread;
        }
        OpacityFilter filter = new OpacityFilter(0);
        bimages.addElement(filter.filter(bimage, null));
        return true;
    }

    private boolean initImageSequence(String name, int count)
    {
        if (count <=0) return false;
        Vector<Image> images = new Vector<Image>();
        String extension = name.substring(name.lastIndexOf("."));
        String base = name.substring(0, name.lastIndexOf("."));
        boolean greaterTen = count>9;
        if (greaterTen)
            base = base.substring(0, base.length()-2);
        else
            base = base.substring(0, base.length()-1);
        for (int i=0; i<count; i++)
        {
            String path = base;
            if ((i<10) && (greaterTen)) path+="0";
            path+=i;
            path+=extension;
            if (count == 1) path = name;
            Image image = getImageTrueSize(path);
            images.addElement(image);
        }

        boolean interrupt = false;

        do
        {
        try
        {
            interrupt = false;
            tracker.waitForAll();
            for (int i=0; i<images.size(); i++)
            {
                Image image = images.elementAt(i);
                BufferedImage bimage = UtilityImage.toBufferedImage(image);
                bimages.addElement(bimage);
            }
        } catch (InterruptedException e)
        {
            interrupt=true;
            System.out.println("Error loading images!");
            e.printStackTrace();
        //    return false;
        }
        }
        while (interrupt);


        return true;
    }

    public java.awt.Image getImageTrueSize(String path)
    {
         String cacheKey = path;
         if (mImageCache.get(cacheKey) != null)
             return mImageCache.get(cacheKey);
        java.awt.Image image;
        java.io.File file =new java.io.File(path);
        if (file.exists())
        {
            image =toolkit.createImage(path);
            mImageCache.put(cacheKey, image);
            tracker.addImage(image, id++);
            return image;
        }
        return null;
    }

    public void transformOpaque(int opaqueness)
    {
        Vector<BufferedImage> newBimages = new Vector<BufferedImage>();
        for (int i=0; i<bimages.size(); i++)
        {
            BufferedImage image = bimages.elementAt(i);
            OpacityFilter filter = new OpacityFilter(opaqueness);
            BufferedImage bimage = filter.filter(image, null);
            newBimages.addElement(bimage);
        }
        bimages= newBimages;
    }

    public void transformScale(int percent)
    {
    }

    public void transformScale(int h, int w)
    {

        Vector<BufferedImage> newBimages = new Vector<BufferedImage>();
        for (int i=0; i<bimages.size(); i++)
        {
            BufferedImage image = bimages.elementAt(i);
            Image iimage = image.getScaledInstance(w, h, java.awt.Image.SCALE_SMOOTH);
            BufferedImage bimage = UtilityImage.toBufferedImage(iimage);
            newBimages.addElement(bimage);
        }
        bimages= newBimages;

    }

    public void transformRotate()
    {
    }
}
