/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package csa.gui;

import java.util.*;

/**
 *
 * @author Malban
 */
public class TimingTriggerer
{
    class Trigger
    {
        TriggerCallback trigger;
        int timing;
        int state;
        Object o;
    }
    private long resolution = 200; // 1/5 second
    private boolean stop = true;
    Vector <Trigger> mTriggers = new Vector<Trigger>();

    public void deinit()
    {
        stop = true;

    }
    public void start()
    {
        new Thread()
        {
            @Override public void run()
            {
                while (!stop)
                {
                    try
                    {
                        sleep(resolution);
                        if (!stop)
                        {
                            synchronized (mTriggers)
                            {
                                for (int i = mTriggers.size()-1; i>=0 ; i--)
                                {
                                    Trigger trigger = mTriggers.elementAt(i);
                                    trigger.timing-=resolution;
    //System.out.println("Tm: "+trigger.timing);
                                    if (trigger.timing <=0)
                                    {
                                        mTriggers.removeElement(trigger);
                                        trigger.trigger.doIt(trigger.state, trigger.o);
                                    }
                                }
                                if (mTriggers.size()==0)
                                {
                                    stop=true;
                                }
                            }
                        }
                    }
                    catch (Exception e)
                    {
                        e.printStackTrace();
                    }
                }
                mTriggers = null;
            }
        }.start();
    }

    public void setResolution(int res)
    {
        resolution = res;
    }

    public void stop()
    {
        stop = true;
    }

    public void addTrigger(TriggerCallback trigger, int timing, int state, Object o)
    {
        if (mTriggers == null)
            mTriggers = new Vector<Trigger>();
        Trigger t = new Trigger();
        t.trigger = trigger;
        t.timing = timing;
        t.state = state;
        t.o = o;
        mTriggers.addElement(t);
        if (stop)
        {
            stop = false;
            start();
        }
    }
}
