/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package jtooly;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.Vector;

/**
 *
 * @author Malban
 */
public class Wordlist
{
    public static final long MAX_MEMEORY_LENGTH = 10000000;
    public static int M_MEMORY = 0;
    public static int M_FILE_BASED = 1;

    boolean toUpper = false;
    boolean toLower = false;
    boolean firstUpperThanLower = false;
    Vector<String> prefix = new Vector<String> ();
    Vector<String> postfix = new Vector<String> ();


    @SuppressWarnings("UseOfObsoleteCollectionType")
    Vector<String> list = new Vector<String>();
    int current = 0;
    boolean loaded = false;
    
    long fileLength=0; 
    File fileIn = null;
    int mode = M_MEMORY;
    int returnLength=1;
    long filePos = 0;
    boolean eof = true;
    String filename="";

    int maxWordLen = 0;
    int minWordLen = 0;


    public boolean isLoaded() {return loaded;}
    
    Wordlist(String fn)
    {
        filename = fn;
        current = 0;
        fileIn = new File (filename);
        fileLength = fileIn.length();

        if (MAX_MEMEORY_LENGTH >= fileLength)
        {
        }
        else
        {
            int mode = M_FILE_BASED;
            returnLength = csa.util.UtilityString.getReturnLengthOfStringFile(fileIn);
        }
        filePos = 0;
        readOn();
    }

    void readOn()
    {
        try
        {
            current = 0;
            list = new Vector<String>();
            FileReader reader = new FileReader(fileIn);
            BufferedReader f = new BufferedReader(reader);
            f.skip(filePos);

            String line;
            while ((!(eof = ((line = f.readLine()) == null))) && (filePos<MAX_MEMEORY_LENGTH))
            {
                list.addElement(line);
                filePos += line.length();
                filePos += returnLength;
            }
            f.close();
            loaded = true;
        } catch (Throwable e)
        {
        }
    }


    void reset()
    {
        current = 0;
        filePos = 0;
        if (mode == M_FILE_BASED)
        {
            readOn();
        }
    }

    boolean isOver()
    {
        return current >= size() && eof;
    }

    int size()
    {
        if (mode == M_FILE_BASED)
            return -list.size();
        return list.size();
    }

    int getPos()
    {
        return current;
    }

    String getCurrentInc()
    {
        String c = getCurrent();
        current++;
        String word = getCurrent();

        while (
                (((maxWordLen != 0) && (word.length()>maxWordLen)) ||
                ((minWordLen != 0) && (word.length()<minWordLen))) &&
                ( (!isOver()))
                )
        {
            word = "";
            current++;
            if (current >=list.size())
            {
                if (mode == M_FILE_BASED)
                {
                    if (!eof)
                    {
                        readOn();
                    }
                }
            }
            if (!isOver())
                word = getCurrent();
            c = word;
        }
        return c;
    }

    String getCurrent()
    {
        if (isOver())
        {
            return "";
        }
        String word = list.elementAt(current);
        if (toLower) word = word.toLowerCase();
        else if(toUpper) word = word.toUpperCase();
        else if(firstUpperThanLower)
        {
            if (word.length()>0)
            {
                word = word.substring(1).toLowerCase();
                word = list.elementAt(current).substring(0,1).toUpperCase()+word;
            }
        }
        return word;
    }

    public boolean processAndSave()
    {
        File ausgabedatei;
        FileWriter fw;
        BufferedWriter bw;

        String to = filename+"_1";
        ausgabedatei = new File(to);


        try
        {
            fw = new FileWriter(ausgabedatei);
            bw = new BufferedWriter(fw);
            while (!isOver())
            {
                String word = getCurrentInc();

                if (word.length() != 0)
                    bw.write(word+"\n");
            }
            bw.close();
        }
        catch (Throwable e)
        {
            e.printStackTrace();
        }
        return true;
    }
}
