/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package jtooly.crypt;

import java.util.HashMap;
import java.util.Vector;
import jtooly.numberhelper.Bin;

/**
 * // Info unter: http://alasdairking.me.uk/brailletrans/
 * @author salchr
 */
class Letter
{
    byte bitMap;
    char letter;
    Letter(byte bm, char l)
    {
        letter = l;
        bitMap = bm;
    }
}
public class Braille
{
/** Bit 0 Bit 3
 *  Bit 1 Bit 4
 *  Bit 2 Bit 5
 */


    static Letter[] letters={
        new Letter((byte) Bin.toBin("000000"),' '),
        new Letter((byte) Bin.toBin("000001"),'A'),
        new Letter((byte) Bin.toBin("000010"),'1'),
        new Letter((byte) Bin.toBin("000011"),'B'),
        new Letter((byte) Bin.toBin("000100"),"'".charAt(0)),
        new Letter((byte) Bin.toBin("000101"),'K'),
        new Letter((byte) Bin.toBin("000110"),'2'),
        new Letter((byte) Bin.toBin("000111"),'L'),
        new Letter((byte) Bin.toBin("001000"),'@'),
        new Letter((byte) Bin.toBin("001001"),'C'),
        new Letter((byte) Bin.toBin("001010"),'I'),
        new Letter((byte) Bin.toBin("001011"),'F'),
        new Letter((byte) Bin.toBin("001100"),'/'),
        new Letter((byte) Bin.toBin("001101"),'M'),
        new Letter((byte) Bin.toBin("001110"),'S'),
        new Letter((byte) Bin.toBin("001111"),'P'),
        new Letter((byte) Bin.toBin("010000"),'"'),
        new Letter((byte) Bin.toBin("010001"),'E'),
        new Letter((byte) Bin.toBin("010010"),'3'),
        new Letter((byte) Bin.toBin("010011"),'H'),
        new Letter((byte) Bin.toBin("010100"),"9".charAt(0)),
        new Letter((byte) Bin.toBin("010101"),'O'),
        new Letter((byte) Bin.toBin("010110"),'6'),
        new Letter((byte) Bin.toBin("010111"),'R'),
        new Letter((byte) Bin.toBin("011000"),'^'),
        new Letter((byte) Bin.toBin("011001"),'D'),
        new Letter((byte) Bin.toBin("011010"),'J'),
        new Letter((byte) Bin.toBin("011011"),'G'),
        new Letter((byte) Bin.toBin("011100"),'>'),
        new Letter((byte) Bin.toBin("011101"),'N'),
        new Letter((byte) Bin.toBin("011110"),'T'),
        new Letter((byte) Bin.toBin("011111"),'Q'),
        new Letter((byte) Bin.toBin("100000"),','),
        new Letter((byte) Bin.toBin("100001"),'*'),
        new Letter((byte) Bin.toBin("100010"),'5'),
        new Letter((byte) Bin.toBin("100011"),'<'),
        new Letter((byte) Bin.toBin("100100"),"-".charAt(0)),
        new Letter((byte) Bin.toBin("100101"),'U'),
        new Letter((byte) Bin.toBin("100110"),'8'),
        new Letter((byte) Bin.toBin("100111"),'V'),
        new Letter((byte) Bin.toBin("101000"),'.'),
        new Letter((byte) Bin.toBin("101001"),'%'),
        new Letter((byte) Bin.toBin("101010"),'['),
        new Letter((byte) Bin.toBin("101011"),'$'),
        new Letter((byte) Bin.toBin("101100"),'+'),
        new Letter((byte) Bin.toBin("101101"),'X'),
        new Letter((byte) Bin.toBin("101110"),'!'),
        new Letter((byte) Bin.toBin("101111"),'&'),
        new Letter((byte) Bin.toBin("110000"),';'),
        new Letter((byte) Bin.toBin("110001"),':'),
        new Letter((byte) Bin.toBin("110010"),'4'),
        new Letter((byte) Bin.toBin("110011"),'\\'),
        new Letter((byte) Bin.toBin("110100"),"0".charAt(0)),
        new Letter((byte) Bin.toBin("110101"),'Z'),
        new Letter((byte) Bin.toBin("110110"),'7'),
        new Letter((byte) Bin.toBin("110111"),'('),
        new Letter((byte) Bin.toBin("111000"),'_'),
        new Letter((byte) Bin.toBin("111001"),'?'),
        new Letter((byte) Bin.toBin("111010"),'W'),
        new Letter((byte) Bin.toBin("111011"),']'),
        new Letter((byte) Bin.toBin("111100"),'#'),
        new Letter((byte) Bin.toBin("111101"),'Y'),
        new Letter((byte) Bin.toBin("111110"),')'),
        new Letter((byte) Bin.toBin("111111"),'='),
    };
    static HashMap<Byte, String> bToChar = new HashMap<Byte, String>();
    static HashMap<String, Byte> charToB = new HashMap<String, Byte>();
    static
    {
        for(int i=0; i< letters.length; i++)
        {
            bToChar.put(letters[i].bitMap, ""+letters[i].letter);
            charToB.put(""+letters[i].letter, letters[i].bitMap);
        }
    }

    public static String stringToBrailleString(String bs)
    {
        return brailleText(toBraille(bs));
    }

    public static byte[] toBraille(String s)
    {
        s = s.toUpperCase();
        byte[] bb = new byte[s.length()];

        for (int i=0; i < s.length(); i++)
        {
            String current = s.substring(i,i+1);
            Byte B = charToB.get(current);
            if (B == null) B = charToB.get("?");
            bb[i] = B;
        }
        return bb;
    }

    public static String toCString(byte[] b)
    {
        String s="";

        for (int i=0; i < b.length; i++)
        {
            String current = bToChar.get(b[i]);
            if (current == null) current = "?";
            s += current;
        }
        return s;
    }

    // expects String like
    // 0- 0-
    // 00 --
    // 0- -0 ...
    // spaces will be eliminated
    // length must be dividable by 3!
    public static String brailleStringToString(String bs)
    {
        return toCString(brailleStringToByte(bs));
    }

    public static byte[] brailleStringToByte(String bs)
    {
        String s=csa.util.UtilityString.replace(bs, " ", "");
        s=csa.util.UtilityString.replace(s, "\n", "");
        
        if (s.length()%3 != 0)
            return new byte[0]; // must be dividable by 3!

        int third = s.length()/3;
        byte[] ret = new byte[third/2];

        for (int i=0; i < third-1; i+=2)
        {
            byte b=0;
            String s1 = s.substring(i, i+1);
            String s4 = s.substring(i+1, i+2);

            String s2 = s.substring(i+third, i+1+third);
            String s5 = s.substring(i+1+third, i+2+third);

            String s3 = s.substring(i+2*third, i+1+2*third);
            String s6 = s.substring(i+1+2*third, i+2+2*third);

            if (!s1.equals("-")) b+=1;
            if (!s2.equals("-")) b+=2;
            if (!s3.equals("-")) b+=4;
            if (!s4.equals("-")) b+=8;
            if (!s5.equals("-")) b+=16;
            if (!s6.equals("-")) b+=32;
            ret[i/2] = b;
        }
        return ret;
    }


    public static String singleBrailleChar(byte b)
    {
        String p1="-";
        String p2="-";
        String p3="-";
        String p4="-";
        String p5="-";
        String p6="-";

        if ((b & 1) >0)  p1="O";
        if ((b & 2) >0)  p2="O";
        if ((b & 4) >0)  p3="O";
        if ((b & 8) >0)  p4="O";
        if ((b & 16) >0) p5="O";
        if ((b & 32) >0) p6="O";

        String ret = p1+p4+" \n"+p2+p5+" \n"+p3+p6+" ";
        return ret;
    }
    // line 1 - 3
    public static String brailleTextLine(byte[] b, int line)
    {
        String ret="";
        for (int i=0; i< b.length; i++)
        {
            String p1="-";
            String p2="-";
            String p3="-";
            String p4="-";
            String p5="-";
            String p6="-";
            if ((b[i] & 1) >0)  p1="O";
            if ((b[i] & 2) >0)  p2="O";
            if ((b[i] & 4) >0)  p3="O";
            if ((b[i] & 8) >0)  p4="O";
            if ((b[i] & 16) >0) p5="O";
            if ((b[i] & 32) >0) p6="O";
            if (line == 1)
                ret += p1+p4+" ";
            if (line == 2)
                ret += p2+p5+" ";
            if (line == 3)
                ret += p3+p6+" ";
        }
        return ret;
    }
    public static String brailleText(byte[] b)
    {
        return brailleTextLine(b,1)+"\n"+brailleTextLine(b,2)+"\n"+brailleTextLine(b,3);
    }
}
