/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package jtooly.crypt;

import java.util.zip.CRC32;

/**
 *
 * @author Malban
 */
public class CRC {
  private static final long POLY64REV = 0xd800000000000000L;

       private static final long[] LOOKUPTABLE;

       static {
           LOOKUPTABLE = new long[0x100];
           for (int i = 0; i < 0x100; i++) {
               long v = i;
               for (int j = 0; j < 8; j++) {
                   if ((v & 1) == 1) {
                       v = (v >>> 1) ^ POLY64REV;
                   } else {
                       v = (v >>> 1);
                   }
               }
               LOOKUPTABLE[i] = v;
           }
       }
        /**
        * Calculates the CRC64 checksum for the given data array.
        *
        * @param data
        *            data to calculate checksum for
        * @return checksum value
        */
       private static long checksum(final byte[] data) {
           long sum = 0;
           for (int i = 0; i < data.length; i++) {
               final int lookupidx = ((int) sum ^ data[i]) & 0xff;
               sum = (sum >>> 8) ^ LOOKUPTABLE[lookupidx];
           }
           return sum;
       }

    public static String CRC64(String in)
    {
        return ""+CRC.checksum(in.getBytes());
    }
    public static String CRC32(String in)
    {
        CRC32 c = new CRC32();
        c.update(in.getBytes());
        return ""+c.getValue();
    }
}
