/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package jtooly.crypt;

import jtooly.numberhelper.Int;

/**
 *
 * @author Malban
 */
public class CreditCard {
    // see: http://www.beachnet.com/~hstiles/cardtype.html
    // Supported for now: Mastercard!

    static String reason="";
    public static String getReason() {return reason;}

    public static boolean checkMasterCard(String number)
    {
        reason = "";
        number = csa.util.UtilityString.replaceWhiteSpaces(number, "");
        number = csa.util.UtilityString.replace(number, " ", "");

        if (number.length() != 16)
        {
            reason = "Wrong length: "+number.length()+" (should be 16)";
            return false;
        }
        String prefix = number.substring(0,0+2);
        if (!( (prefix.equals("51")) ||
             (prefix.equals("52")) ||
             (prefix.equals("53")) ||
             (prefix.equals("54")) ||
             (prefix.equals("55"))))
        {
            reason = "Wrong prefex: "+prefix+" (should be 51-55)";
            return false;
        }
        int[] digits = new int[16];
        int missingDigit = -1;
        for(int i=0; i<16; i++)
        {
            digits[i] = Int.getDigit(number, i);
            if (digits[i] == -1)
            {
                missingDigit = i;
                digits[i] = 0;
            }
        }

        int sum=0;
        for(int i=15; i>=0; i--)
        {
            if (i%2 == 1)
                sum += digits[i];
            else
                sum += Int.getDigitSum(2*digits[i]);
        }

        int[] doubleSum = {0,2,4,6,8,1,3,5,7,9};
        if ((sum % 10 != 0)|| (missingDigit != -1))
        {
            reason = "LUHN Check not passed: "+sum+" (should devideable by 10)";
            if (missingDigit != -1)
            {
                int offset = (int) (sum / 10);
                offset = sum - (offset*10);
                offset = 10 - offset;
                if (offset == 10) offset = 0;

                if (missingDigit%2 == 1)
                {
                    reason += "\nMissing digit is: " + offset;
                }
                else
                {
                    reason += "\nMissing digit is(d): " + doubleSum[offset];
                }
            }
            return false;
        }
        return true;
    }

    // missing digit MUST be present as a non digit of any kind!
    // return -1 no missing digit or no mastercard
    public static int getMissingDigitMasterCard(String number)
    {
        reason = "";
        number = csa.util.UtilityString.replaceWhiteSpaces(number, "");
        number = csa.util.UtilityString.replace(number, " ", "");

        if (number.length() != 16)
        {
            reason = "Wrong length: "+number.length()+" (should be 16)";
            return -1;
        }
        String prefix = number.substring(0,0+2);
/*
        if (!( (prefix.equals("51")) ||
             (prefix.equals("52")) ||
             (prefix.equals("53")) ||
             (prefix.equals("54")) ||
             (prefix.equals("55"))))
        {
            reason = "Wrong prefex: "+prefix+" (should be 51-55)";
            return -1;
        }
*/
        int[] digits = new int[16];
        int missingDigit = -1;
        for(int i=0; i<16; i++)
        {
            digits[i] = Int.getDigit(number, i);
            if (digits[i] == -1)
            {
                missingDigit = i;
                digits[i] = 0;
            }
        }

        int sum=0;
        for(int i=15; i>=0; i--)
        {
            if (i%2 == 1)
                sum += digits[i];
            else
                sum += Int.getDigitSum(2*digits[i]);
        }

        int[] doubleSum = {0,2,4,6,8,1,3,5,7,9};
        if ((sum % 10 != 0)|| (missingDigit != -1))
        {
            reason = "LUHN Check not passed: "+sum+" (should devideable by 10)";
            if (missingDigit != -1)
            {
                int offset = (int) (sum / 10);
                offset = sum - (offset*10);
                offset = 10 - offset;
                if (offset == 10) offset = 0;

                if (missingDigit%2 == 1)
                {
                    reason += "\nMissing digit is: " + offset;
                    return offset;
                }
                else
                {
                    reason += "\nMissing digit is(d): " + doubleSum[offset];
                    return doubleSum[offset];
                }
            }
            return -1;
        }
        return -1;
    }

}
