/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package jtooly.crypt;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;

/**
 *
 * @author Malban
 */
public class Morse
{

    Morse()
    {
    }

    public static boolean isMorse(String s)
    {
        s = tidyMorse(s);
        return s.matches("^[ /.-]*$");
    }

    public static String convert(String s)
    {
        if (isMorse(s))
        {
            return morse2text(s);
        } else
        {
            return text2morse(s);
        }
    }

    public static String tidyText(String s)
    {
        s = s.toUpperCase();
        s = s.trim();
        s = s.replaceAll("\\s+", " ");
        return s;
    }

    public static String text2morse(String s)
    {
        s = tidyText(s);
        char ac[] = s.toCharArray();
        ArrayList arraylist = new ArrayList();
        for (int i = 0; i < s.length(); i++)
        {
            Character character = new Character(ac[i]);
            arraylist.add(hMorse.get(character));
        }

        String s1 = "";
        for (int j = 0; j < arraylist.size(); j++)
        {
            String s2 = (String) arraylist.get(j);
            if (s2 == null)
            {
                s2 = "?";
            }
            s1 = s1 + s2 + " ";
        }

        s1 = s1.trim();
        return s1;
    }

    public static String tidyMorse(String s)
    {
        s = s.trim();
        s = s.replaceAll("\\|", "/");
        s = s.replaceAll("/", " / ");
        s = s.replaceAll("\\s+", " ");
        s = s.replaceAll("(/ )+/", "/");
        s = s.replaceAll("^ / ", "");
        s = s.replaceAll(" / $", "");
        s = s.replaceAll("_", "-");
        return s;
    }

    public static String morse2text(String s)
    {
        s = tidyMorse(s);
        String as[] = s.split(" ");
        ArrayList arraylist = new ArrayList();
        for (int i = 0; i < as.length; i++)
        {
            String s1 = as[i];
            arraylist.add(hText.get(s1));
        }

        String s2 = "";
        for (int j = 0; j < arraylist.size(); j++)
        {
            Character character = (Character) arraylist.get(j);
            if (character == null)
            {
                character = new Character('?');
            }
            s2 = s2 + character;
        }

        return s2;
    }
    static final int DITS_PER_WORD = 50;
    static HashMap hMorse;
    static HashMap hText;

    static
    {
        hMorse = new HashMap();
        hText = new HashMap();
        hMorse.put(new Character('A'), ".-");
        hMorse.put(new Character('B'), "-...");
        hMorse.put(new Character('C'), "-.-.");
        hMorse.put(new Character('D'), "-..");
        hMorse.put(new Character('E'), ".");
        hMorse.put(new Character('F'), "..-.");
        hMorse.put(new Character('G'), "--.");
        hMorse.put(new Character('H'), "....");
        hMorse.put(new Character('I'), "..");
        hMorse.put(new Character('J'), ".---");
        hMorse.put(new Character('K'), "-.-");
        hMorse.put(new Character('L'), ".-..");
        hMorse.put(new Character('M'), "--");
        hMorse.put(new Character('N'), "-.");
        hMorse.put(new Character('O'), "---");
        hMorse.put(new Character('P'), ".--.");
        hMorse.put(new Character('Q'), "--.-");
        hMorse.put(new Character('R'), ".-.");
        hMorse.put(new Character('S'), "...");
        hMorse.put(new Character('T'), "-");
        hMorse.put(new Character('U'), "..-");
        hMorse.put(new Character('V'), "...-");
        hMorse.put(new Character('W'), ".--");
        hMorse.put(new Character('X'), "-..-");
        hMorse.put(new Character('Y'), "-.--");
        hMorse.put(new Character('Z'), "--..");
        hMorse.put(new Character('1'), ".----");
        hMorse.put(new Character('2'), "..---");
        hMorse.put(new Character('3'), "...--");
        hMorse.put(new Character('4'), "....-");
        hMorse.put(new Character('5'), ".....");
        hMorse.put(new Character('6'), "-....");
        hMorse.put(new Character('7'), "--...");
        hMorse.put(new Character('8'), "---..");
        hMorse.put(new Character('9'), "----.");
        hMorse.put(new Character('0'), "-----");
        hMorse.put(new Character('.'), ".-.-.-");
        hMorse.put(new Character(','), "--..--");
        hMorse.put(new Character(':'), "---...");
        hMorse.put(new Character('?'), "..--..");
        hMorse.put(new Character('\''), ".----.");
        hMorse.put(new Character('-'), "-....-");
        hMorse.put(new Character('/'), "-..-.");
        hMorse.put(new Character('('), "-.--.-");
        hMorse.put(new Character(')'), "-.--.-");
        hMorse.put(new Character('"'), ".-..-.");
        hMorse.put(new Character('@'), ".--.-.");
        hMorse.put(new Character('='), "-...-");
        hMorse.put(new Character(' '), "/");
        Character character;
        String s;
        for (Iterator iterator = hMorse.entrySet().iterator(); iterator.hasNext(); hText.put(s, character))
        {
            java.util.Map.Entry entry = (java.util.Map.Entry) iterator.next();
            character = (Character) entry.getKey();
            s = (String) entry.getValue();
        }

    }
}

